/** @file server.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.1
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef SERVER_CMDLINE_H
#define SERVER_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef SERVER_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define SERVER_CMDLINE_PARSER_PACKAGE "para_server"
#endif

#ifndef SERVER_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define SERVER_CMDLINE_PARSER_VERSION "0.3.5"
#endif

enum enum_color { color_arg_yes = 0 , color_arg_no, color_arg_auto };

/** @brief Where the command line options are stored */
struct server_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *detailed_help_help; /**< @brief Print help, including all details and hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * loglevel_arg;	/**< @brief set loglevel (default='warning').  */
  char * loglevel_orig;	/**< @brief set loglevel original value given at command line.  */
  const char *loglevel_help; /**< @brief set loglevel help description.  */
  enum enum_color color_arg;	/**< @brief activate color output (default='auto').  */
  char * color_orig;	/**< @brief activate color output original value given at command line.  */
  const char *color_help; /**< @brief activate color output help description.  */
  char ** log_color_arg;	/**< @brief select a color for one type of log message.  */
  char ** log_color_orig;	/**< @brief select a color for one type of log message original value given at command line.  */
  unsigned int log_color_min; /**< @brief select a color for one type of log message's minimum occurreces */
  unsigned int log_color_max; /**< @brief select a color for one type of log message's maximum occurreces */
  const char *log_color_help; /**< @brief select a color for one type of log message help description.  */
  int daemon_flag;	/**< @brief run as background daemon (default=off).  */
  const char *daemon_help; /**< @brief run as background daemon help description.  */
  char * user_arg;	/**< @brief run as the given user.  */
  char * user_orig;	/**< @brief run as the given user original value given at command line.  */
  const char *user_help; /**< @brief run as the given user help description.  */
  char * group_arg;	/**< @brief set group id.  */
  char * group_orig;	/**< @brief set group id original value given at command line.  */
  const char *group_help; /**< @brief set group id help description.  */
  int port_arg;	/**< @brief listening port (default='2990').  */
  char * port_orig;	/**< @brief listening port original value given at command line.  */
  const char *port_help; /**< @brief listening port help description.  */
  char * logfile_arg;	/**< @brief where to write log output.  */
  char * logfile_orig;	/**< @brief where to write log output original value given at command line.  */
  const char *logfile_help; /**< @brief where to write log output help description.  */
  char * config_file_arg;	/**< @brief (default='~/.paraslash/server.conf').  */
  char * config_file_orig;	/**< @brief (default='~/.paraslash/server.conf') original value given at command line.  */
  const char *config_file_help; /**< @brief (default='~/.paraslash/server.conf') help description.  */
  char * user_list_arg;	/**< @brief (default='~/.paraslash/server.users').  */
  char * user_list_orig;	/**< @brief (default='~/.paraslash/server.users') original value given at command line.  */
  const char *user_list_help; /**< @brief (default='~/.paraslash/server.users') help description.  */
  int autoplay_flag;	/**< @brief start playing on startup (default=off).  */
  const char *autoplay_help; /**< @brief start playing on startup help description.  */
  int autoplay_delay_arg;	/**< @brief time to wait before streaming (default='0').  */
  char * autoplay_delay_orig;	/**< @brief time to wait before streaming original value given at command line.  */
  const char *autoplay_delay_help; /**< @brief time to wait before streaming help description.  */
  int announce_time_arg;	/**< @brief grace time for clients (default='300').  */
  char * announce_time_orig;	/**< @brief grace time for clients original value given at command line.  */
  const char *announce_time_help; /**< @brief grace time for clients help description.  */
  char * afs_database_dir_arg;	/**< @brief location of the database.  */
  char * afs_database_dir_orig;	/**< @brief location of the database original value given at command line.  */
  const char *afs_database_dir_help; /**< @brief location of the database help description.  */
  char * afs_socket_arg;	/**< @brief Command socket for afs (default='/var/paraslash/afs_command_socket').  */
  char * afs_socket_orig;	/**< @brief Command socket for afs original value given at command line.  */
  const char *afs_socket_help; /**< @brief Command socket for afs help description.  */
  char * afs_initial_mode_arg;	/**< @brief Mood or playlist to load on startup..  */
  char * afs_initial_mode_orig;	/**< @brief Mood or playlist to load on startup. original value given at command line.  */
  const char *afs_initial_mode_help; /**< @brief Mood or playlist to load on startup. help description.  */
  int http_port_arg;	/**< @brief tcp port for http streaming (default='8000').  */
  char * http_port_orig;	/**< @brief tcp port for http streaming original value given at command line.  */
  const char *http_port_help; /**< @brief tcp port for http streaming help description.  */
  int http_default_deny_flag;	/**< @brief make the http ACL a whitelist (default=off).  */
  const char *http_default_deny_help; /**< @brief make the http ACL a whitelist help description.  */
  char ** http_access_arg;	/**< @brief add an entry to the http ACL.  */
  char ** http_access_orig;	/**< @brief add an entry to the http ACL original value given at command line.  */
  unsigned int http_access_min; /**< @brief add an entry to the http ACL's minimum occurreces */
  unsigned int http_access_max; /**< @brief add an entry to the http ACL's maximum occurreces */
  const char *http_access_help; /**< @brief add an entry to the http ACL help description.  */
  int http_no_autostart_flag;	/**< @brief do not open tcp port on startup (default=off).  */
  const char *http_no_autostart_help; /**< @brief do not open tcp port on startup help description.  */
  int http_max_clients_arg;	/**< @brief maximal number of connections (default='-1').  */
  char * http_max_clients_orig;	/**< @brief maximal number of connections original value given at command line.  */
  const char *http_max_clients_help; /**< @brief maximal number of connections help description.  */
  int dccp_port_arg;	/**< @brief port for dccp streaming (default='8000').  */
  char * dccp_port_orig;	/**< @brief port for dccp streaming original value given at command line.  */
  const char *dccp_port_help; /**< @brief port for dccp streaming help description.  */
  int dccp_default_deny_flag;	/**< @brief make the dccp ACL a whitelist (default=off).  */
  const char *dccp_default_deny_help; /**< @brief make the dccp ACL a whitelist help description.  */
  char ** dccp_access_arg;	/**< @brief add an entry to the dccp ACL.  */
  char ** dccp_access_orig;	/**< @brief add an entry to the dccp ACL original value given at command line.  */
  unsigned int dccp_access_min; /**< @brief add an entry to the dccp ACL's minimum occurreces */
  unsigned int dccp_access_max; /**< @brief add an entry to the dccp ACL's maximum occurreces */
  const char *dccp_access_help; /**< @brief add an entry to the dccp ACL help description.  */
  int dccp_max_clients_arg;	/**< @brief maximal number of connections (default='-1').  */
  char * dccp_max_clients_orig;	/**< @brief maximal number of connections original value given at command line.  */
  const char *dccp_max_clients_help; /**< @brief maximal number of connections help description.  */
  char ** udp_target_arg;	/**< @brief add udp target with optional port.  */
  char ** udp_target_orig;	/**< @brief add udp target with optional port original value given at command line.  */
  unsigned int udp_target_min; /**< @brief add udp target with optional port's minimum occurreces */
  unsigned int udp_target_max; /**< @brief add udp target with optional port's maximum occurreces */
  const char *udp_target_help; /**< @brief add udp target with optional port help description.  */
  int udp_no_autostart_flag;	/**< @brief do not start sending (default=off).  */
  const char *udp_no_autostart_help; /**< @brief do not start sending help description.  */
  int udp_default_port_arg;	/**< @brief udp port to send to (default='8000').  */
  char * udp_default_port_orig;	/**< @brief udp port to send to original value given at command line.  */
  const char *udp_default_port_help; /**< @brief udp port to send to help description.  */
  char * udp_mcast_iface_arg;	/**< @brief outgoing udp multicast interface.  */
  char * udp_mcast_iface_orig;	/**< @brief outgoing udp multicast interface original value given at command line.  */
  const char *udp_mcast_iface_help; /**< @brief outgoing udp multicast interface help description.  */
  int udp_header_interval_arg;	/**< @brief duration for sending header (default='2000').  */
  char * udp_header_interval_orig;	/**< @brief duration for sending header original value given at command line.  */
  const char *udp_header_interval_help; /**< @brief duration for sending header help description.  */
  int udp_ttl_arg;	/**< @brief set time to live value (default='-1').  */
  char * udp_ttl_orig;	/**< @brief set time to live value original value given at command line.  */
  const char *udp_ttl_help; /**< @brief set time to live value help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int detailed_help_given ;	/**< @brief Whether detailed-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int loglevel_given ;	/**< @brief Whether loglevel was given.  */
  unsigned int color_given ;	/**< @brief Whether color was given.  */
  unsigned int log_color_given ;	/**< @brief Whether log_color was given.  */
  unsigned int daemon_given ;	/**< @brief Whether daemon was given.  */
  unsigned int user_given ;	/**< @brief Whether user was given.  */
  unsigned int group_given ;	/**< @brief Whether group was given.  */
  unsigned int port_given ;	/**< @brief Whether port was given.  */
  unsigned int logfile_given ;	/**< @brief Whether logfile was given.  */
  unsigned int config_file_given ;	/**< @brief Whether config_file was given.  */
  unsigned int user_list_given ;	/**< @brief Whether user_list was given.  */
  unsigned int autoplay_given ;	/**< @brief Whether autoplay was given.  */
  unsigned int autoplay_delay_given ;	/**< @brief Whether autoplay_delay was given.  */
  unsigned int announce_time_given ;	/**< @brief Whether announce_time was given.  */
  unsigned int afs_database_dir_given ;	/**< @brief Whether afs_database_dir was given.  */
  unsigned int afs_socket_given ;	/**< @brief Whether afs_socket was given.  */
  unsigned int afs_initial_mode_given ;	/**< @brief Whether afs_initial_mode was given.  */
  unsigned int http_port_given ;	/**< @brief Whether http_port was given.  */
  unsigned int http_default_deny_given ;	/**< @brief Whether http_default_deny was given.  */
  unsigned int http_access_given ;	/**< @brief Whether http_access was given.  */
  unsigned int http_no_autostart_given ;	/**< @brief Whether http_no_autostart was given.  */
  unsigned int http_max_clients_given ;	/**< @brief Whether http_max_clients was given.  */
  unsigned int dccp_port_given ;	/**< @brief Whether dccp_port was given.  */
  unsigned int dccp_default_deny_given ;	/**< @brief Whether dccp_default_deny was given.  */
  unsigned int dccp_access_given ;	/**< @brief Whether dccp_access was given.  */
  unsigned int dccp_max_clients_given ;	/**< @brief Whether dccp_max_clients was given.  */
  unsigned int udp_target_given ;	/**< @brief Whether udp_target was given.  */
  unsigned int udp_no_autostart_given ;	/**< @brief Whether udp_no_autostart was given.  */
  unsigned int udp_default_port_given ;	/**< @brief Whether udp_default_port was given.  */
  unsigned int udp_mcast_iface_given ;	/**< @brief Whether udp_mcast_iface was given.  */
  unsigned int udp_header_interval_given ;	/**< @brief Whether udp_header_interval was given.  */
  unsigned int udp_ttl_given ;	/**< @brief Whether udp_ttl was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct server_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure server_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure server_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *server_args_info_purpose;
/** @brief the usage string of the program */
extern const char *server_args_info_usage;
/** @brief all the lines making the help output */
extern const char *server_args_info_help[];
/** @brief all the lines making the detailed help output (including hidden options and details) */
extern const char *server_args_info_detailed_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int server_cmdline_parser (int argc, char * const *argv,
  struct server_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use server_cmdline_parser_ext() instead
 */
int server_cmdline_parser2 (int argc, char * const *argv,
  struct server_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int server_cmdline_parser_ext (int argc, char * const *argv,
  struct server_args_info *args_info,
  struct server_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int server_cmdline_parser_dump(FILE *outfile,
  struct server_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int server_cmdline_parser_file_save(const char *filename,
  struct server_args_info *args_info);

/**
 * Print the help
 */
void server_cmdline_parser_print_help(void);
/**
 * Print the detailed help (including hidden options and details)
 */
void server_cmdline_parser_print_detailed_help(void);
/**
 * Print the version
 */
void server_cmdline_parser_print_version(void);

/**
 * Initializes all the fields a server_cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void server_cmdline_parser_params_init(struct server_cmdline_parser_params *params);

/**
 * Allocates dynamically a server_cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized server_cmdline_parser_params structure
 */
struct server_cmdline_parser_params *server_cmdline_parser_params_create(void);

/**
 * Initializes the passed server_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void server_cmdline_parser_init (struct server_args_info *args_info);
/**
 * Deallocates the string fields of the server_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void server_cmdline_parser_free (struct server_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use server_cmdline_parser_config_file() instead
 */
int server_cmdline_parser_configfile (char * const filename,
  struct server_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int server_cmdline_parser_config_file (char * const filename,
  struct server_args_info *args_info,
  struct server_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int server_cmdline_parser_required (struct server_args_info *args_info,
  const char *prog_name);

extern char *server_cmdline_parser_loglevel_values[] ;	/**< @brief Possible values for loglevel.  */
extern char *server_cmdline_parser_color_values[] ;	/**< @brief Possible values for color.  */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* SERVER_CMDLINE_H */
